// @todo: rename the file
(function ($, Drupal, d3) {
  Drupal.visualnData.drawers.visualnLineChartDrawer = function(drawings, vuid) {
    var drawing = drawings[vuid];
    var html_selector = drawing.html_selector;
    $('.' + html_selector).append('<svg width="960" height="500">');
    var stroke_color = drawing.drawer.config.color;
    var y_axis_label = drawing.drawer.config.y_label;

    var svg = d3.select("." + html_selector + " svg"),
        margin = {top: 20, right: 20, bottom: 30, left: 50},
        width = +svg.attr("width") - margin.left - margin.right,
        height = +svg.attr("height") - margin.top - margin.bottom,
        g = svg.append("g").attr("transform", "translate(" + margin.left + "," + margin.top + ")");

    var parseTime = d3.timeParse("%d-%b-%y");

    var x = d3.scaleTime()
        .rangeRound([0, width]);

    var y = d3.scaleLinear()
        .rangeRound([height, 0]);

    var line = d3.line()
        .x(function(d) { return x(d.date); })
        .y(function(d) { return y(d.close); });

    /*
    d3.tsv(drawing.adapter.fileUrl, function(d) {
      d.date = parseTime(d.date);
      d.close = +d.close;
      return d;
    }, function(error, data) {
      if (error) throw error;
    */
    var data = drawing.adapter.responseData;
    $(data).each(function(index, d){
      data[index].date = parseTime(d.date);
      data[index].close = +d.close;
    });

      x.domain(d3.extent(data, function(d) { return d.date; }));
      y.domain(d3.extent(data, function(d) { return d.close; }));

      g.append("g")
          .attr("transform", "translate(0," + height + ")")
          .call(d3.axisBottom(x))
        .select(".domain")
          .remove();

      g.append("g")
          .call(d3.axisLeft(y))
        .append("text")
          .attr("fill", "#000")
          .attr("transform", "rotate(-90)")
          .attr("y", 6)
          .attr("dy", "0.71em")
          .attr("text-anchor", "end")
          //.text("Price ($)");
          .text(y_axis_label);

      g.append("path")
          .datum(data)
          .attr("fill", "none")
          //.attr("stroke", "steelblue")
          .attr("stroke", stroke_color)
          .attr("stroke-linejoin", "round")
          .attr("stroke-linecap", "round")
          .attr("stroke-width", 1.5)
          .attr("d", line);
    //});
  };

})(jQuery, Drupal, d3);

